Kerbal Space Program - Bug #5205

Ship on clean Laythe intercept crashes to Tylo
07/02/2015 09:07 PM - Kasuha
Description

| verified this very old bug is still present in KSP 1.0.4
The conic patch system does not notice there is upcoming intercept until the ship moves inside the SOI of the interfering body.

There are multiple issues related to conic patches and future trajectory evaluation and | am not able to decide whether they are all
the same problem or whether they are different unrelated problems. For instance, similar behavior as reported here can be simulated
on transfer from Kerbin to Mun. If this gets picked up | can provide additional materials and reproduction data.

The fact that explosion was rendered in map view is unrelated visual glitch.

Reproduction steps:

Load the quicksave

Switch to Map view to review the trajectory
Time warp forward

Related issues:
Related to Kerbal Space Program - Bug #5387: Shallow low velocity sphere of i... Needs Clarificad®07/2015

History

#1 - 07/09/2015 06:56 PM - RexKramer
- Status changed from New to Confirmed

- % Done changed from 0 to 10

| duplicated this on OSX 1.0.4 by loading the quicksave provided. I've seen (rarely) similar events around Kerbin, for example unexpected Mun
encounters while exiting Kerbin's SOI, but just assumed it was operator error on my part.

| am curious, did you originally set Laythe as a target as you approached Jool? | tried targeting other moons (including Tylo) in the quicksave, and
was not able to get the game to recognize the Tylo encounter.

#2 - 07/09/2015 07:10 PM - RexKramer

One interesting thing | found in the player.log file was this:
[OrbitDriver]: On-Rails SOI Transition from Tylo to Tylo.
Transition UT Range: 5900013.4 - 5910013.4.

Transition UT: 5909861.118. Iterations: 20.

Prior to that, Jool was the dominant body. Not sure if this is a normal message or not, but the statement 'SOI transition from Tylo to Tylo." indicates to
me that perhaps the game already thought it was within Tylo's SOI, and therefore would not need to plot encounter information?

The above section of the player log appeared shortly before the collision with Tylo.

#4 - 07/09/2015 10:30 PM - Kasuha

The quicksave is result of determined effort to get undetected intercept which ends up in a crash. "surprise slingshots" from Tylo happen to me
regularly whenever | visit Jool, however "surprise crash" only happens rarely.

Probable reason is that solver or a branch of one used for this particular set of orbital parameters contains an error and does not find a solution which
exists. Since | have no idea how these solvers are organized, | also have no idea what properties must orbital parameters have for this to occur. | can,
however, replicate such undetected intercept anytime e.g. on Mun SOI from low Kerbin orbit. The situation has three modes:

1/ the intercept is completely undetected
2/ the intercept randomly flickers on and off, even on time warp when the orbital parameters are fixed
3/ there is partial intercept with no SOI entry point and no periapsis, just a small part of trajectory inside the SOI and exit point.

These three situations happen on closely grouped sets of orbital parameters so they may be result of the same solver bug, but it is not certain

| believe the "transition from Tylo to Tylo" is caused by the fact that the game suddenly realized the ship is inside Tylo SOI although it did not expect
that to happen. Initially, Jool was the dominant body, and conic patches were drawn relative to it, not to Tylo. Also in the save file, the initial dominant
body of the ship is Jool.

#5 - 07/10/2015 02:37 AM - RexKramer

First, thanks Kasuha for the information. This bug has been forwarded to the experimental, QA, and developers.
Of the three modes you listed above, I've seen all three while attempting to transfer to Duna from a Kerbol orbit, originating from Kerbin.

If you find additional information that may be helpful, this would be a good place to report it.

#6 - 07/10/2015 08:53 PM - Kasuha
- File Sudden Changes.sfs added

- File Invisible.sfs added

- File Partial.sfs added

- File Flickering.sfs added

One bit of additional detail | remembered about this bug is that in some cases, an intercept suddenly disappears or changes during time warp towards
intercept. | prepared quicksaves with all these modes. They are relatively easy to prepare, | set up minimum dv transfer burn towards Mun and then
recorded them as my ship was burning through the transfer burn.

Reproduction: load the quicksave, switch to map view, look at the trajectory, focus on Mun, time warp through the transfer and watch changes.

#7 - 07/10/2015 08:54 PM - Kasuha

Note to the last update: some of notes to uploaded files are mixed up - | put some observations next to wrong files. Sorry about that.

#8 - 07/12/2015 05:01 PM - Kasuha

- File encounter _flicker.sfs added

Another possible manifestation of the bug - or possibly unrelated one. An orbit intersect marker flickering between two values. Occurs on rendezvous.

The closest intersect marker flickers between real value (0.2 km) and value of unclear origin (6.7 km). The second value does not correspond to
distance one orbit later.
More distant intersect marker is stable, only switches between "intersect 1" and "intersect 2" colors.

After passing the intersect marker, the originally flickering marker continues to flicker between 143.3 km (real value next orbit) and 6.7 km
Markers continue to flicker in non-physics time warp.
Steps to reproduce:

e |oad the quicksave encounter_flicker.sfs
¢ switch to Map view
¢ check out the closest encounter markers.

#9 - 07/23/2015 09:21 PM - Alchemist

Another possible explanation (at lest for some related cases):

If the current fragment of patched conics intersects SOI of several moons only intersection with the first (closest to the planet) moon not the first
intersection (the actual SOI switch that may occur with higher moons) is detected. Seems that the patched conics system is checking moon SOI
intersects starting with the closest to the planet and stopping at the first intersection found without checking if the other moons SOl intersection occurs
first.

As example let's take LKO-Minmus transfer trajectory:

0) no actual intersection occurs - elliptic trajectory displayed

1) Mun encounter happens first - Mun encounter displayed properly, if the trajectory after Munar slingshot intersects Minmus SOI, second intersect is
displayed

2) only Minmus encounter found - Minmus encounter displayed properly (other bugs might be present), if the trajectory after Minmus flyby then
encounters the Mun, the second encounter will be displayed as well

3) the trajectory intersects Minmus SOI, but if there wasn't Minmus it would have Mun encounter on the way back down (after Minmus encounter!) -
only the (hypothetical!) Mun encounter displayed, but Minmus encounter is ignored! until you suddenly find yourself in Minmus SOI.

The same seems to be true in cases when predicted Laythe encounter ignores Tylo and Vall encounters that happen before that.

#10 - 07/25/2015 10:22 AM - Kasuha

Alchemist wrote:
If the current fragment of patched conics intersects SOI of several moons only intersection with the first (closest to the planet) moon not the first
intersection (the actual SOI switch that may occur with higher moons) is detected. Seems that the patched conics system is checking moon SOI
intersects starting with the closest to the planet and stopping at the first intersection found without checking if the other moons SOl intersection
occurs first.

If that was the case, it would still be a bug. But this is certainly not the case.

First, when | was setting up the example, | was in parameter space where the intercept did not show up regardless whether there was or was not
Laythe intercept. The Laythe intercept just randomly popped up as | was trying to tweak the trajectory to crash into Tylo.

Second, it is possible to set up similar situation in Kerbin SOI where the ship will crash into Mun without the Mun intercept showing up until the ship
enters the Mun SOI. Mun is the closest moon in Kerbin SOI and the orbit does not even have to intersect orbit of Minmus.

#11 - 07/26/2015 09:34 PM - Alchemist

Second, it is possible to set up similar situation in Kerbin SOI where the ship will crash into Mun without the Mun intercept showing up until the
ship enters the Mun SOI

Yes, | can confirm that this also happens sometimes (depending on orbital parameters?). We are likely having at least 2 different bugs at once here.

#12 - 08/20/2015 12:13 AM - featherwinglove
- File OrbitBugCompressed.avi added

Have a 19 second sample vid from the tracking station of a Mun free return trajectory. It is with Mun free returns that | most reliably see this issue.

#13 - 09/08/2015 04:21 AM - RexKramer

- Related to Bug #5387: Shallow low velocity sphere of influence encounter teleportation added

#14 - 07/17/2016 09:38 AM - TriggerAu
- Status changed from Confirmed to Needs Clarification

- % Done changed from 10 to 0

#15 - 07/26/2016 08:35 PM - Alchemist

- File Escape not shown.png added

- Status changed from Needs Clarification to Updated
- % Done changed from 0 to 10

At least some of these SOI change detection issues are still there.

Also attaching an interesting case of forgotten SOI change bug:
The apoapsis is clearly outside Kerbin SOI, but it doesn't show escape... because it found Mun intersect on the next orbit!

#16 - 07/29/2016 12:07 PM - sal_vager

- Status changed from Updated to Need More Info

- % Done changed from 10 to 0

Hiya Alchemist, can you attach some new saves that show the remaining issues specifically please.
The issues that are no longer present will get in the way of those that remain.

#17 - 07/29/2016 01:42 PM - Alchemist

- File Escape not shown Mun intercept.rar added

- File Minmus impact flickers.sfs added
- File Minmus intercept affected by Mun.rar added

Here is a couple of missed transitions due to other transitions after them, | could easily reproduce right away. You can play with slight
prograde/retrograde boosts to see the correct intercept appearing and disappearing with the appearance of another intercept after it on the initial orbit
patch. This totally smells of a function that calls return on the first body in the list that gives a Sol change, when in fact it has to remember it and
continue checking other possibilities, comparing transition ETA.

Plus the notorious flickering/disappearing intercept that seems to be inclination-sensitive. Something that is not that reliably reproducible, but what
appears out of nowhere annoyingly often when you don't need it.

#18 - 10/11/2016 10:59 PM - Kasuha
- File tylo_crash_1_2.sfs added

| tested the issue (the invisible Tylo intercept) with 1.2 release and the bug is still there. Original save cannot be used to reproduce the bug as the new
release interprets the position/timing differently and the ship is passing Tylo along a different trajectory.

Attaching tylo_crash_1_2.sfs compatible with KSP 1.2 with a ship again on trajectory with invisible tylo intercept which can be used to reproduce the
bug using original reproduction steps.

#19 - 10/13/2016 11:53 AM - sal_vager
- Status changed from Need More Info to Updated
- % Done changed from 0 to 10

Thanks Kasuha, marking as updated.

Files

quicksave.sfs 23.7 KB 07/02/2015 Kasuha
screenshot25.png 320 KB 07/02/2015 Kasuha
screenshot26.png 286 KB 07/02/2015 Kasuha
screenshot27.png 584 KB 07/02/2015 Kasuha
Sudden Changes.sfs 78.6 KB 07/10/2015 Kasuha
Invisible.sfs 78.6 KB 07/10/2015 Kasuha
Partial.sfs 78.6 KB 07/10/2015 Kasuha
Flickering.sfs 78.6 KB 07/10/2015 Kasuha
encounter_flicker.sfs 987 KB 07/12/2015 Kasuha
OrbitBugCompressed.avi 1.1 MB 08/20/2015 featherwinglove
Escape not shown.png 54.8 KB 07/26/2016 Alchemist
Escape not shown Mun intercept.rar 14.4 KB 07/29/2016 Alchemist
Minmus impact flickers.sfs 54.2 KB 07/29/2016 Alchemist
Minmus intercept affected by Mun.rar 21.6 KB 07/29/2016 Alchemist
tylo_crash_1_2.sfs 37.1 KB 10/11/2016 Kasuha
